//-----ScriptName=Set_daysInMonth
//---------------------------------------------------------------------------------------------
// Murphy Scripting
// - Leave EventName as Set_daysInMonth for main script method
//---------------------------------------------------------------------------------------------
void Set_daysInMonth ()
{
	uint currentHandle;
	int month, isLeapYear, days, day;
	
	currentHandle = VariableIDs.RealTimeClock_Set_Month;
	smRead(currentHandle, month);
	
	currentHandle = VariableIDs.RealTimeClock_Set_isLeapYear;
	smRead(currentHandle, isLeapYear);
	
	currentHandle = VariableIDs.RealTimeClock_Set_Day;
	smRead(currentHandle, day);
	
	switch(month)
	{
		case 1:
			days = 31;
		break;
		
		case 2:
			if(isLeapYear==1)
			{
				days = 29;
			}
			else
			{
				days = 28;
			}
		break;
		
		case 3:
			days = 31;
		break;
		
		case 4:
			days = 30;
		break;
		
		case 5:
			days = 31;
		break;
		
		case 6:
			days = 30;
		break;
		
		case 7:
			days = 31;
		break;
		
		case 8:
			days = 31;
		break;
		
		case 9:
			days = 30;
		break;
		
		case 10:
			days = 31;
		break;
		
		case 11:
			days = 30;
		break;
		
		case 12:
			days = 31;
		break;
		
		default:
			days = 31;
	}
	
	currentHandle = VariableIDs.RealTimeClock_Set_daysInMonth;
	smWrite(currentHandle, days);
	
	day = day % ( days + 1 );
	
	currentHandle = VariableIDs.RealTimeClock_Set_Day;
	smWrite(currentHandle, day);
}

//-----ScriptName=Set_isLeapYear
//---------------------------------------------------------------------------------------------
// Murphy Scripting
// - Leave EventName as Set_isLeapYear for main script method
//---------------------------------------------------------------------------------------------
void Set_isLeapYear ()
{
	uint currentHandle;
	int year, isLeapYear;
	
	currentHandle = VariableIDs.RealTimeClock_Set_Year;
	smRead(currentHandle, year);
	
	if( ( year % 400 ) == 0 )
	{
		isLeapYear = 1;
	}
	else if( ( year % 100 ) == 0 )
	{
		isLeapYear = 0;
	}
	else if( ( year % 4 ) == 0 )
	{
		isLeapYear = 1;
	}
	else
	{
		isLeapYear = 0;
	}
	
	currentHandle = VariableIDs.RealTimeClock_Set_isLeapYear;
	smWrite(currentHandle, isLeapYear);
	
	Set_daysInMonth();
}

//-----ScriptName=Move Menu
//---------------------------------------------------------------------------------------------
// Murphy Scripting
// - Leave EventName as $MoveScrollWindow2$ for main script method
//---------------------------------------------------------------------------------------------
int MenuCurrentPosX = 83;
int MenuCurrentPosY = -180;
int MenuTargetPosY = 30;
int MenuTargetPosYShow = 30;
int MenuTargetPosYHide = -180;

int MenuSweepSize = 10;

void MoveMenuUp ()
{
	MenuTargetPosY = MenuTargetPosYShow;
	sendEvent(EventIDs.TR_MoveMenu);
	sendEvent(EventIDs.SettingsMenu_Rollovers_6);
}

void MoveMenuDown ()
{
	MenuTargetPosY = MenuTargetPosYHide;
	sendEvent(EventIDs.TR_MoveMenu);
	sendEvent(EventIDs.SettingsMenu_Rollovers_5);
}

void MoveMenu () 
{
    if (MenuCurrentPosY != MenuTargetPosY)		// check if at target
	{
		if ( MenuCurrentPosY < MenuTargetPosY)
		{
			MenuCurrentPosY += MenuSweepSize;
		}
		else if ( MenuCurrentPosY > MenuTargetPosY)
		{
			MenuCurrentPosY -= MenuSweepSize;
		}
		
		screenApiMove(ScreenObjectIDs.SettingsMenu,MenuCurrentPosX, MenuCurrentPosY);
		processScreenApi();
		
	}
	else
	{
		sendEvent(EventIDs.TR_MenuAtTarget);
		if (MenuCurrentPosY == MenuTargetPosYShow)
		{
			sendEvent(EventIDs.TR_ShowMenu);
		}
		else
		{
			sendEvent(EventIDs.TR_Exit_CloseMenu);
			sendEvent(EventIDs.SettingsMenu_Rollovers_OFF);
		}
	}

}


//-----ScriptName=Job Log Write
//---------------------------------------------------------------------------------------------
// Murphy Scripting
// - Leave EventName as Job_Log_Write for main script method
//---------------------------------------------------------------------------------------------
void Job_Log_Write () 
{
   double year, month, day, hour, minute, job_hour, job_minute, job_second, pto_hour, pto_minute, pto_second, fuel_start, fuel_end, job_fuel;
   string filename, job_record, job_name, job_date, job_record_time, job_duration, pto_duration;
   file f;
   
   smRead( VariableIDs.RealTimeClock_Year, year);
   smRead( VariableIDs.RealTimeClock_Month, month);
   smRead( VariableIDs.RealTimeClock_Day, day);
   smRead( VariableIDs.RealTimeClock_Hour, hour);
   smRead( VariableIDs.RealTimeClock_Minute, minute);
   smRead( VariableIDs.JOB_TIMER_Hours, job_hour);
   smRead( VariableIDs.JOB_TIMER_Minutes, job_minute);
   smRead( VariableIDs.JOB_TIMER_Seconds, job_second);
   smRead( VariableIDs.PTO_TIMER_Hours, pto_hour);
   smRead( VariableIDs.PTO_TIMER_Minutes, pto_minute);
   smRead( VariableIDs.PTO_TIMER_Seconds, pto_second);
   smRead( VariableIDs.Fuel_Job_Start, fuel_start);
   smRead( VariableIDs.J1939_Engine_Total_Fuel_Used, fuel_end);   
   cultureGetString( StringIDs.Job_Name,job_name,0);
   
//Add to job_record
   
   job_record=job_name+","+month+"/"+day+"/"+year+","+hour+":";
   
   if( minute < 10)
   	{
   		job_record += "0";
	}
	
	job_record += minute+","+job_hour+":";
	
	if( job_minute < 10)
	{
		job_record += "0";
	}
	
	job_record += job_minute+":";
	
	if( job_second < 10)
	{
		job_record += "0";
	}
	
	job_record += job_second+","+pto_hour+":";
	
	if( pto_minute < 10)
	{
		job_record += "0";
	}
	
	job_record += pto_minute+":";
	
	if( pto_second < 10)
	{
		job_record += "0";
	}
	
	job_record += pto_second+",";

	job_fuel=(fuel_end-fuel_start)/3.785;
	
	job_record += job_fuel+"\n";


//job_date
	job_date=month+"/"+day+"/"+year;
    cultureSetString (StringIDs.Job_Date,job_date,true);

//job_record_time
	job_record_time=hour+":";
   
	if( minute < 10)
   		{
   			job_record_time += "0";
		}
	
	job_record_time += minute;
    cultureSetString (StringIDs.Job_Record_Time,job_record_time,true);

//job_duration
	job_duration=job_hour+":";
   
	if( job_minute < 10)
   		{
   			job_duration += "0";
		}
	
	job_duration += job_minute+":";

	if( job_second < 10)
	{
		job_duration += "0";
	}
	
	job_duration += job_second;

    cultureSetString (StringIDs.Job_Duration,job_duration,true);

//pto_duration
	pto_duration=pto_hour+":";
   
	if( pto_minute < 10)
   		{
   			pto_duration += "0";
		}
	
	pto_duration += pto_minute+":";

	if( pto_second < 10)
	{
		pto_duration += "0";
	}
	
	pto_duration += pto_second;

    cultureSetString (StringIDs.PTO_Duration,pto_duration,true);

//job_fuel_used
	smWrite( VariableIDs.Job_Fuel_Used, job_fuel);
	
//Write File

	filename="job_log.csv";

	if ( statFile(filename)==false)
		{
		if( f.open(filename, "w") >= 0)
			{
				f.writeString("Job ID,Date,Time,Job Time,PTO Time,Fuel Consumed (gal)\n");
	        	f.writeString(job_record);
	            f.close();
			}
		}
	else
		{
		if( f.open(filename, "a") >= 0 )
		   	{
		       	f.writeString(job_record);
		        f.close();
	       	}
		}	

    cultureSetString (StringIDs.Latest_Job_Info,job_record,true);

}




//-----ScriptName=Job Name Init
//---------------------------------------------------------------------------------------------
// Murphy Scripting
// - Leave EventName as Job_Name_Init for main script method
//---------------------------------------------------------------------------------------------
void Job_Name_Init () 
{
    cultureSetString (StringIDs.Job_Name,"",true);
    cultureSetString (StringIDs.Latest_Job_Info,"",true);
}

//-----ScriptName=Job Report Download
//---------------------------------------------------------------------------------------------
// Murphy Scripting
// - Leave EventName as Job_Report_Download for main script method
//---------------------------------------------------------------------------------------------
void Job_Report_Download () 
{
	mountUSB( EventIDs.mountUSBcomplete );

	copyToUSB("job_log.csv", EventIDs.copyToUSBcomplete, EventIDs.USB_Not_Connected );
               
	unmountUSB( EventIDs.GoToDownloadComplete ); 
}

//-----ScriptName=Delete Job Report
//---------------------------------------------------------------------------------------------
// Murphy Scripting
// - Leave EventName as Delete_Job_Report for main script method
//---------------------------------------------------------------------------------------------
void Delete_Job_Report () 
{
 	deleteFile("job_log.csv", EventIDs.jobReportDeleted );   
}

//-----ScriptName=MountUSBRequest
//---------------------------------------------------------------------------------------------
// Murphy Scripting
// - Leave EventName as MountUSBRequest for main script method
//---------------------------------------------------------------------------------------------
void MountUSBRequest ()
{
	string tmpStr = "MountUSBRequest";
	Print( tmpStr );
//	mountUSB( EventIDs.MountUSBComplete, EventIDs.MountUSBFail );
	mountUSB( EventIDs.MountUSBComplete );
	sendEvent( EventIDs.Main_to_Slate );
}

//-----ScriptName=SCR_BatterySource_1
//---------------------------------------------------------------------------------------------
// Murphy Scripting
// - Leave EventName as SCR_BatterySource for main script method
//---------------------------------------------------------------------------------------------
void SCR_BatterySource () 
{
	double batterySource;
	
	if (smRead (VariableIDs.J1939_Engine_Alternator_Potential, batterySource))
   		{
			smWrite(VariableIDs.Battery_Source, 0);
		}
	else if (smRead (VariableIDs.J1939_Engine_Battery_Potential_Voltage, batterySource))
		{
			smWrite(VariableIDs.Battery_Source, 1);
		}
	else if (smRead (VariableIDs.J1939_Engine_Electrical_Potential_Voltage, batterySource))
		{
			smWrite(VariableIDs.Battery_Source, 2);
		}

}

//-----ScriptName=SCR MVEC Locations
//---------------------------------------------------------------------------------------------
// Murphy Scripting
// - Leave EventName as MVEC_Locations for main script method
//---------------------------------------------------------------------------------------------
void MVEC_Locations () 
{
	int location;
	string mvec_locationname;
    smRead (VariableIDs.MVEC_Location_Names,location);
	switch(location)
		{
			//R260 Locations
			case 220000:
			mvec_locationname="LIFT IN";
			break;
			
			case 220001:
			mvec_locationname="LIFT OUT";
			break;
			
			case 220002:
			mvec_locationname="TILT UP";
			break;
			
			case 220003:
			mvec_locationname="TILT DOWN";
			break;
			
			case 220004:
			mvec_locationname="BOOM UP";
			break;
			
			case 220005:
			mvec_locationname="BOOM DOWN";
			break;
			
			case 220006:
			mvec_locationname="NOT USED";
			break;
			
			case 220007:
			mvec_locationname="NOT USED";
			break;
			
			case 220008:
			mvec_locationname="FOLD UP";
			break;
			
			case 220009:
			mvec_locationname="FOLD DOWN";
			break;
			
			case 220010:
			mvec_locationname="LEFT WINCH IN";
			break;
			
			case 220011:
			mvec_locationname="LEFT WINCH OUT";
			break;
			
			case 220012:
			mvec_locationname="RIGHT WINCH IN";
			break;
			
			case 220013:
			mvec_locationname="RIGHT WINCH OUT";
			break;
			
			case 220014:
			mvec_locationname="BOOM OUT";
			break;
			
			case 220015:
			mvec_locationname="BOOM IN";
			break;

			case 220016:
			mvec_locationname="NOT USED";
			break;
			
			case 220020:
			mvec_locationname="SUPPLY VOLTAGE";
			break;
			
			case 220018:
			mvec_locationname="NOT USED";
			break;			

			//mVEC1 Locations
			case 230100:
			case 230116:
			mvec_locationname="PASSENGER DOCK";
			break;
			
			case 230101:
			case 230119:
			mvec_locationname="RIGHT TURN";
			break;

			case 230102:
			case 230122:
			mvec_locationname="BRAKE";
			break;

			case 230103:
			case 230117:
			mvec_locationname="REVERSE";
			break;

			case 230104:
			case 230123:
			mvec_locationname="UNDERLIFT LIGHTS";
			break;

			case 230105:
			case 230121:
			mvec_locationname="IGNITION OUT";
			break;

			case 230106:
			case 230118:
			mvec_locationname="PTO";
			break;

			case 230107:
			case 230120:
			case 230125:
			mvec_locationname="NOT USED";
			break;

			case 230124:
			mvec_locationname="Communication";
			break;

			//mVEC2 Locations
			case 230200:
			case 230216:
			mvec_locationname="MARKERS";
			break;
			
			case 230201:
			case 230219:
			mvec_locationname="UPPER LIGHTS";
			break;

			case 230202:
			case 230222:
			mvec_locationname="MAIN BEACON";
			break;

			case 230203:
			case 230217:
			mvec_locationname="AUX BEACON";
			break;

			case 230204:
			case 230223:
			mvec_locationname="WORK UP LIGHTS";
			break;

			case 230205:
			case 230221:
			mvec_locationname="CONTROLS POWER";
			break;

			case 230206:
			case 230218:
			mvec_locationname="MARKER FLASHERS";
			break;

			case 230207:
			case 230220:
			mvec_locationname="TOOLBOX LIGHTS";
			break;

			case 230224:
			mvec_locationname="Communication";
			break;

			case 230225:
			mvec_locationname="NOT USED";
			break;

			//mVEC3 Locations
			case 230300:
			case 230316:
			mvec_locationname="TAIL LIGHTS";
			break;
			
			case 230301:
			case 230319:
			mvec_locationname="BOOM LIGHTS";
			break;

			case 230302:
			case 230322:
			mvec_locationname="DRIVERS DOCK";
			break;

			case 230303:
			case 230317:
			mvec_locationname="SWIVEL LIGHTS";
			break;

			case 230304:
			case 230323:
			mvec_locationname="LEFT TURN";
			break;

			case 230305:
			case 230321:
			mvec_locationname="AUX 1";
			break;

			case 230306:
			case 230318:
			mvec_locationname="AUX 2";
			break;
			
			case 230307:
			case 230320:
			case 230325:
			mvec_locationname="NOT USED";
			break;

			case 230324:
			mvec_locationname="Communication";
			break;

			default:
			mvec_locationname="";
			break;
		}
	cultureSetString(StringIDs.MVEC_Location_Name,mvec_locationname,true);
}


_VariableIDs VariableIDs;
class _VariableIDs
{
  uint Battery_Source;
  uint Fuel_Job_Start;
  uint J1939_Engine_Alternator_Potential;
  uint J1939_Engine_Battery_Potential_Voltage;
  uint J1939_Engine_Electrical_Potential_Voltage;
  uint J1939_Engine_Total_Fuel_Used;
  uint Job_Fuel_Used;
  uint JOB_TIMER_Hours;
  uint JOB_TIMER_Minutes;
  uint JOB_TIMER_Seconds;
  uint MVEC_Location_Names;
  uint PTO_TIMER_Hours;
  uint PTO_TIMER_Minutes;
  uint PTO_TIMER_Seconds;
  uint RealTimeClock_Day;
  uint RealTimeClock_Hour;
  uint RealTimeClock_Minute;
  uint RealTimeClock_Month;
  uint RealTimeClock_Set_Day;
  uint RealTimeClock_Set_daysInMonth;
  uint RealTimeClock_Set_isLeapYear;
  uint RealTimeClock_Set_Month;
  uint RealTimeClock_Set_Year;
  uint RealTimeClock_Year;

   _VariableIDs () 
   {
	Battery_Source = 4;
	Fuel_Job_Start = 86;
	J1939_Engine_Alternator_Potential = 181;
	J1939_Engine_Battery_Potential_Voltage = 184;
	J1939_Engine_Electrical_Potential_Voltage = 190;
	J1939_Engine_Total_Fuel_Used = 201;
	Job_Fuel_Used = 246;
	JOB_TIMER_Hours = 250;
	JOB_TIMER_Minutes = 251;
	JOB_TIMER_Seconds = 252;
	MVEC_Location_Names = 321;
	PTO_TIMER_Hours = 337;
	PTO_TIMER_Minutes = 338;
	PTO_TIMER_Seconds = 339;
	RealTimeClock_Day = 342;
	RealTimeClock_Hour = 344;
	RealTimeClock_Minute = 346;
	RealTimeClock_Month = 347;
	RealTimeClock_Set_Day = 349;
	RealTimeClock_Set_daysInMonth = 350;
	RealTimeClock_Set_isLeapYear = 352;
	RealTimeClock_Set_Month = 354;
	RealTimeClock_Set_Year = 356;
	RealTimeClock_Year = 357;

   }
}

_EventIDs EventIDs;
class _EventIDs
{
  uint copyToUSBcomplete;
  uint GoToDownloadComplete;
  uint jobReportDeleted;
  uint Main_to_Slate;
  uint mountUSBcomplete;
  uint MountUSBComplete;
  uint MountUSBFail;
  uint SettingsMenu_Rollovers_5;
  uint SettingsMenu_Rollovers_6;
  uint SettingsMenu_Rollovers_OFF;
  uint TR_Exit_CloseMenu;
  uint TR_MenuAtTarget;
  uint TR_MoveMenu;
  uint TR_ShowMenu;
  uint USB_Not_Connected;

   _EventIDs () 
   {
	copyToUSBcomplete = 14174;
	GoToDownloadComplete = 14175;
	jobReportDeleted = 14177;
	Main_to_Slate = 14295;
	mountUSBcomplete = 14173;
	MountUSBComplete = 14333;
	MountUSBFail = 14334;
	SettingsMenu_Rollovers_5 = 14082;
	SettingsMenu_Rollovers_6 = 14083;
	SettingsMenu_Rollovers_OFF = 14077;
	TR_Exit_CloseMenu = 14050;
	TR_MenuAtTarget = 14048;
	TR_MoveMenu = 14049;
	TR_ShowMenu = 14047;
	USB_Not_Connected = 14179;

   }
}

_StringIDs StringIDs;
class _StringIDs
{
  uint Job_Date;
  uint Job_Duration;
  uint Job_Name;
  uint Job_Record_Time;
  uint Latest_Job_Info;
  uint MVEC_Location_Name;
  uint PTO_Duration;

   _StringIDs () 
   {
	Job_Date = 566;
	Job_Duration = 568;
	Job_Name = 564;
	Job_Record_Time = 567;
	Latest_Job_Info = 565;
	MVEC_Location_Name = 570;
	PTO_Duration = 569;

   }
}

_ScreenObjectIDs ScreenObjectIDs;
class _ScreenObjectIDs
{
  uint SettingsMenu;

   _ScreenObjectIDs () 
   {
	SettingsMenu = 20321;

   }
}
